//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DodgerBlue
#property indicator_color2  Crimson
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    Price            = 0;
extern double T3Period         = 32;
extern double T3Hot            = 0.7; 
extern bool   T3Original       = false; 
extern bool   zeroCross        = false;
extern bool   ShowText         = true;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern string UniqueID         = "";
extern color  LineUpColor      = LimeGreen;
extern color  LineDnColor      = Orange;
extern int    LineStyle        = STYLE_DOT;
extern int    LineWidth        = 0;

extern int    TextPositionX    = 628;
extern int    TextPositionY    = 25;
extern color  upTextcolor      = Blue;
extern color  dnTextcolor      = Red;


//
//
//
//
//

double UpH[];
double DnH[]; 
double Upval[];
double Dnval[];
double trend[];
string TextDir = "itrend";

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
      IndicatorBuffers(5);
      SetIndexBuffer(0,UpH);   SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnH);   SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,Upval); 
      SetIndexBuffer(3,Dnval); 
      SetIndexBuffer(4,trend);
      SetLevelValue(0,0);
      
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
     
      IndicatorShortName(timeFrameToString(timeFrame)+"   T3_ITrend ");
   return(0);
}

//
//
//
//
//

int deinit(){ 

   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal()-1; i>=0; i--)
   {
   string name = ObjectName(i); if (StringSubstr(name,0,lookForLength)==lookFor) ObjectDelete(name);
   ObjectDelete(TextDir);
   
   }
   return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
     for (i=limit-1; i>=0; i--)
     {  
         double ma = iMA(NULL,0,1,0,MODE_SMA,Price,i);
          Upval[i] = ma-iT3(ma,T3Period,T3Hot,T3Original,i,0);
          Dnval[i] = -(Low[i]-iT3(ma,T3Period,T3Hot,T3Original,i,1)+High[i]-iT3(ma,T3Period,T3Hot,T3Original,i,2)); 
          UpH[i]   = EMPTY_VALUE;
          DnH[i]   = EMPTY_VALUE;
          trend[i] = trend[i+1];       
          if (zeroCross)
          {
	         if (Upval[i] > 0) trend[i] = 1; 
	         if (Dnval[i] > 0) trend[i] =-1;
	       }
	       else
	       {
	         if (Upval[i] > Dnval[i]) trend[i] = 1; 
	         if (Upval[i] < Dnval[i]) trend[i] =-1;
	       }
	       if (trend[i] == 1) UpH[i] = 1;
          if (trend[i] ==-1) DnH[i] = 1;
	      
	
	
	       //
	       //
	      
	       if (UniqueID!="")
	       {
	           string name = UniqueID+":"+Time[i];
	              ObjectDelete(name);
	              if (trend[i] != trend[i+1])
	              {
	                 color theColor = LineUpColor; if (trend[i]==-1) theColor = LineDnColor;
	                    ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
	                       ObjectSet(name,OBJPROP_COLOR,theColor);
	                       ObjectSet(name,OBJPROP_WIDTH,LineWidth);
	                       ObjectSet(name,OBJPROP_STYLE,LineStyle);
	              }
	       }
      }  
      Commenter(trend[0]);  
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
          trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,T3Period,T3Hot,T3Original,zeroCross,ShowText,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,UniqueID,LineUpColor,LineDnColor,LineStyle,LineWidth,TextPositionX,TextPositionY,upTextcolor,dnTextcolor,4,y);
          UpH[i]   = EMPTY_VALUE;
          DnH[i]   = EMPTY_VALUE;
          if (trend[i] == 1) UpH[i] = 1;
          if (trend[i] ==-1) DnH[i] = 1;
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","H8","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,480,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" - T3_ITrend "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," T3_ITrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][18];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}


void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
      ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPositionX);
      ObjectSet(TextDir,OBJPROP_YDISTANCE,TextPositionY);
      if (Dir == 1) ObjectSetText(TextDir,"ITREND BUY",9,"Arial Black", upTextcolor);
      if (Dir ==-1) ObjectSetText(TextDir,"ITREND SELL",9,"Arial Black",dnTextcolor);
   }
   
return; 
}





